
// VTC1010_IO_UtilityDlg.cpp : implementation file
//

#include "stdafx.h"
#include "VTC1010_IO_Utility.h"
#include "VTC1010_IO_UtilityDlg.h"
#include "VTC1010_IO.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	enum { IDD = IDD_ABOUTBOX };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

// Implementation
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
END_MESSAGE_MAP()


// CVTC1010_IO_UtilityDlg dialog




CVTC1010_IO_UtilityDlg::CVTC1010_IO_UtilityDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CVTC1010_IO_UtilityDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CVTC1010_IO_UtilityDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_TAB1, m_CTabCtrl_Config);
}

BEGIN_MESSAGE_MAP(CVTC1010_IO_UtilityDlg, CDialog)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_WM_DESTROY()
	ON_NOTIFY(TCN_SELCHANGE, IDC_TAB1, &CVTC1010_IO_UtilityDlg::OnTcnSelchangeTab1)
END_MESSAGE_MAP()


// CVTC1010_IO_UtilityDlg message handlers

BOOL CVTC1010_IO_UtilityDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		BOOL bNameValid;
		CString strAboutMenu;
		bNameValid = strAboutMenu.LoadString(IDS_ABOUTBOX);
		ASSERT(bNameValid);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// TODO: Add extra initialization here

	if( 0 == Library_Initial() ) 
		MessageBox("Initial Library failed!!!");

	m_CTabCtrl_Config.InsertItem(0, TEXT("Config 1"));
	m_CTabCtrl_Config.InsertItem(1, TEXT("Config 2"));
	m_CTabCtrl_Config.InsertItem(2, TEXT("Config 3"));
	m_CTabCtrl_Config.InsertItem(3, TEXT("GPIO"));
	m_CTabCtrl_Config.SetCurSel(0);

	RECT Rect;
	m_CTabCtrl_Config.GetItemRect(0, &Rect);
	CSize cSize;
	cSize.cx = Rect.right - Rect.left;
	cSize.cy = Rect.bottom - Rect.top + 20;
	m_CTabCtrl_Config.SetItemSize(cSize);

	CRect rc;
	m_CTabCtrl_Config.GetClientRect(rc);
	rc.top += 21 + 20;
	rc.bottom -= 1;
	rc.left += 1;
	rc.right -= 1;

	m_TabDialog1.Create(IDD_DIALOG1, &m_CTabCtrl_Config);
	m_TabDialog2.Create(IDD_DIALOG2, &m_CTabCtrl_Config);
	m_TabDialog3.Create(IDD_DIALOG3, &m_CTabCtrl_Config);
	m_TabDialog4.Create(IDD_DIALOG4, &m_CTabCtrl_Config);

	m_TabDialog1.MoveWindow(&rc);
	m_TabDialog2.MoveWindow(&rc);
	m_TabDialog3.MoveWindow(&rc);
	m_TabDialog4.MoveWindow(&rc);

	m_TabDialog1.ShowWindow(SW_SHOW);
	m_TabDialog2.ShowWindow(SW_HIDE);
	m_TabDialog3.ShowWindow(SW_HIDE);
	m_TabDialog4.ShowWindow(SW_HIDE);

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CVTC1010_IO_UtilityDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CVTC1010_IO_UtilityDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CVTC1010_IO_UtilityDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}

void CVTC1010_IO_UtilityDlg::OnDestroy()
{
	CDialog::OnDestroy();

	Library_Release(); // Release Library
}

void CVTC1010_IO_UtilityDlg::OnTcnSelchangeTab1(NMHDR *pNMHDR, LRESULT *pResult)
{
	m_TabDialog1.ShowWindow(SW_HIDE);
	m_TabDialog2.ShowWindow(SW_HIDE);
	m_TabDialog3.ShowWindow(SW_HIDE);
	m_TabDialog4.ShowWindow(SW_HIDE);

	int nCurSel = m_CTabCtrl_Config.GetCurSel();
	switch(nCurSel)
	{
	case 0:
		m_TabDialog1.ShowWindow(SW_SHOW);
		break;
	case 1:
		m_TabDialog2.ShowWindow(SW_SHOW);
		break;
	case 2:
		m_TabDialog3.ShowWindow(SW_SHOW);
		break;
	case 3:
		m_TabDialog4.ShowWindow(SW_SHOW);
		break;
	default:
		m_CTabCtrl_Config.SetCurSel(0);
		m_TabDialog1.ShowWindow(SW_SHOW);
		break;
	}

	*pResult = 0;
}
